Index: python/prepareFLEXPART.py
===================================================================
--- python/prepareFLEXPART.py	(revision 02c8c50da359770adb72a6e9287a59e6be76cb36)
+++ python/prepareFLEXPART.py	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
@@ -30,7 +30,9 @@
         - added documentation
         - minor changes in programming style for consistence
+        - BUG: removed call of cleanup-Function after call of prepareFlexpart
+                since it is already called in prepareFlexpart at the end!
 
 @License:
-    (C) Copyright 2014.
+    (C) Copyright 2014-2018.
 
     This software is licensed under the terms of the Apache Licence Version 2.0
@@ -40,5 +42,4 @@
     - A standard python 2.6 or 2.7 installation
     - dateutils
-    - matplotlib (optional, for debugging)
     - ECMWF specific packages, all available from https://software.ecmwf.int/
         ECMWF WebMARS, gribAPI with python enabled, emoslib and
@@ -52,24 +53,23 @@
         surface fields for FLEXPART runs
 """
-
+# ------------------------------------------------------------------------------
+# MODULES
+# ------------------------------------------------------------------------------
 import calendar
 import shutil
 import datetime
 import time
-import os,inspect,sys
+import os
+import inspect
+import sys
 import socket
 from argparse import ArgumentParser, ArgumentDefaultsHelpFormatter
-# add path to submit.py to pythonpath so that python finds its buddies
-localpythonpath=os.path.dirname(os.path.abspath(inspect.getfile(inspect.currentframe())))
-if localpythonpath not in sys.path:
-    sys.path.append(localpythonpath)
-from UIOTools import UIOFiles
-#from string import strip
-from GribTools import GribTools
-from FlexpartTools import ECFlexpart, Control, interpret_args_and_control, cleanup
+import UIOFiles
+import Control
+import Tools
+import ECFlexpart
 
-hostname=socket.gethostname()
-ecapi= 'ecmwf' not in hostname
-
+hostname = socket.gethostname()
+ecapi = 'ecmwf' not in hostname
 try:
     if ecapi:
@@ -78,5 +78,11 @@
     ecapi = False
 
-
+# add path to submit.py to pythonpath so that python finds its buddies
+localpythonpath=os.path.dirname(os.path.abspath(inspect.getfile(inspect.currentframe())))
+if localpythonpath not in sys.path:
+    sys.path.append(localpythonpath)
+# ------------------------------------------------------------------------------
+# FUNCTION
+# ------------------------------------------------------------------------------
 def prepareFLEXPART(args, c):
     '''
@@ -121,5 +127,5 @@
                         day=int(c.end_date[6:]))
 
-    # to deaccumulated the fluxes correctly
+    # to deaccumulate the fluxes correctly
     # one day ahead of the start date and
     # one day after the end date is needed
@@ -128,5 +134,5 @@
 
     # get all files with flux data to be deaccumulated
-    inputfiles = UIOFiles(['.grib', '.grb', '.grib1',
+    inputfiles = UIOFiles.UIOFiles(['.grib', '.grb', '.grib1',
                            '.grib2', '.grb1', '.grb2'])
 
@@ -138,5 +144,5 @@
 
     # deaccumulate the flux data
-    flexpart = ECFlexpart(c, fluxes=True)
+    flexpart = ECFlexpart.ECFlexpart(c, fluxes=True)
     flexpart.write_namelist(c, 'fort.4')
     flexpart.deacc_fluxes(inputfiles, c)
@@ -146,5 +152,5 @@
 
     # get a list of all files from the root inputdir
-    inputfiles = UIOFiles(['.grib', '.grb', '.grib1',
+    inputfiles = UIOFiles.UIOFiles(['.grib', '.grb', '.grib1',
                            '.grib2', '.grb1', '.grb2'])
 
@@ -157,19 +163,18 @@
         start = startm1
 
-    flexpart = ECFlexpart(c, fluxes=False)
+    flexpart = ECFlexpart.ECFlexpart(c, fluxes=False)
     flexpart.create(inputfiles, c)
     flexpart.process_output(c)
 
     # check if in debugging mode, then store all files
+    # otherwise delete temporary files
     if int(c.debug) != 0:
         print('Temporary files left intact')
     else:
-        cleanup(c)
+        Tools.cleanup(c)
 
     return
 
 if __name__ == "__main__":
-    args, c = interpret_args_and_control()
+    args, c = Tools.interpret_args_and_control()
     prepareFLEXPART(args, c)
-    cleanup(c)
-
Index: python/profiling.py
===================================================================
--- python/profiling.py	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
+++ python/profiling.py	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
@@ -0,0 +1,69 @@
+#!/usr/bin/env python
+# -*- coding: utf-8 -*-
+#************************************************************************
+# TODO AP
+# - add description of file
+# - check of license of book content
+#************************************************************************
+"""
+@Author: Anne Philipp (University of Vienna)
+
+@Date: March 2018
+
+@License:
+    (C) Copyright 2018.
+
+    This software is licensed under the terms of the Apache Licence Version 2.0
+    which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
+
+@Requirements:
+    A standard python 2.6 or 2.7 installation
+
+@Description:
+    ...
+"""
+# ------------------------------------------------------------------------------
+# MODULES
+# ------------------------------------------------------------------------------
+from functools import wraps
+import time
+
+# ------------------------------------------------------------------------------
+# FUNCTION
+# ------------------------------------------------------------------------------
+def timefn(fn):
+    '''
+    @Description:
+        Decorator function. It takes the inner function as an argument.
+    '''
+    @wraps(fn)
+    def measure_time(*args, **kwargs):
+        '''
+        @Descripton:
+            Passes the arguments through fn for execution. Around the
+            execution of fn the time is captured to execute the fn function
+            and prints the result along with the function name.
+
+            This is taken from the book "High Performance Python" from
+            Micha Gorelick and Ian Ozsvald, O'Reilly publisher, 2014,
+            ISBN: 978-1-449-36159-4
+
+        @Input:
+            *args: undefined
+                A variable number of positional arguments.
+
+            **kwargs: undefined
+                A variable number of key/value arguments.
+
+        @Return:
+            <nothing>
+        '''
+
+        t1 = time.time()
+        result = fn(*args, **kwargs)
+        t2 = time.time()
+        print("@timefn:" + fn.func_name + " took " + str(t2 - t1) + " seconds")
+
+        return result
+
+    return measure_time
Index: python/submit.py
===================================================================
--- python/submit.py	(revision 02c8c50da359770adb72a6e9287a59e6be76cb36)
+++ python/submit.py	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
@@ -3,8 +3,11 @@
 #************************************************************************
 # TODO AP
-#AP
+#
 # - Change History ist nicht angepasst ans File! Original geben lassen
 # - dead code ? what to do?
 # - seperate operational and reanlysis for clarification
+# - add correct file description
+# - divide in two submits , ondemand und operational
+# -
 #************************************************************************
 """
@@ -15,20 +18,14 @@
 @ChangeHistory:
     November 2015 - Leopold Haimberger (University of Vienna):
-        - using the WebAPI also for general MARS retrievals
         - job submission on ecgate and cca
         - job templates suitable for twice daily operational dissemination
-        - dividing retrievals of longer periods into digestable chunks
-        - retrieve also longer term forecasts, not only analyses and
-          short term forecast data
-        - conversion into GRIB2
-        - conversion into .fp format for faster execution of FLEXPART
 
     February 2018 - Anne Philipp (University of Vienna):
         - applied PEP8 style guide
         - added documentation
-        - minor changes in programming style for consistence
+        - minor changes in programming style (for consistence)
 
 @License:
-    (C) Copyright 2014 UIO.
+    (C) Copyright 2014-2018.
 
     This software is licensed under the terms of the Apache Licence Version 2.0
@@ -37,35 +34,24 @@
 @Requirements:
     - A standard python 2.6 or 2.7 installation
-    - dateutils
-    - matplotlib (optional, for debugging)
-    - ECMWF specific packages, all available from https://software.ecmwf.int/
-        ECMWF WebMARS, gribAPI with python enabled, emoslib and
-        ecaccess web toolkit
 
 @Description:
     Further documentation may be obtained from www.flexpart.eu.
 
-    Functionality provided:
-        Prepare input 3D-wind fields in hybrid coordinates +
-        surface fields for FLEXPART runs
+
 """
 # ------------------------------------------------------------------------------
 # MODULES
 # ------------------------------------------------------------------------------
-import calendar
-import shutil
-import datetime
-import time
-import os, sys, glob
+import os
+import sys
+import glob
 import subprocess
 import inspect
-# add path to submit.py to pythonpath so that python finds its buddies
+# add the pythondir path so that python finds its buddies (from flex_extract)
 localpythonpath = os.path.dirname(os.path.abspath(inspect.getfile(inspect.currentframe())))
 sys.path.append(localpythonpath)
-from UIOTools import UIOFiles
-from string import strip
-from argparse import ArgumentParser, ArgumentDefaultsHelpFormatter
-from GribTools import GribTools
-from FlexpartTools import ECFlexpart, Control, interpret_args_and_control, normalexit, myerror
+
+# software specific classes and modules from flex_extract
+from Tools import interpret_args_and_control, normalexit
 from getMARSdata import getMARSdata
 from prepareFLEXPART import prepareFLEXPART
@@ -76,7 +62,8 @@
     '''
     @Description:
-        Get the arguments from script call and initialize an object from
-        Control class. Decides from the argument "queue" if the local version
-        is done "queue=None" or the gateway version "queue=ecgate".
+        Get the arguments from script call and from Control file.
+        Decides from the argument "queue" if the local version
+        is done "queue=None" or the gateway version with "queue=ecgate"
+        or "queue=cca".
 
     @Input:
@@ -88,4 +75,5 @@
     calledfromdir = os.getcwd()
     args, c = interpret_args_and_control()
+    # on local side
     if args.queue is None:
         if c.inputdir[0] != '/':
@@ -96,4 +84,5 @@
         prepareFLEXPART(args, c)
         normalexit(c)
+    # on ECMWF server
     else:
         submit(args.job_template, c, args.queue)
@@ -102,5 +91,4 @@
 
 def submit(jtemplate, c, queue):
-    #AP divide in two submits , ondemand und operational
     '''
     @Description:
@@ -138,13 +126,11 @@
         lftext = f.read().split('\n')
         insert_point = lftext.index('EOF')
-#AP es gibt mehrere EOFs überprüfen!
 
     # put all parameters of control instance into a list
-    clist = c.tolist()  # reanalysis (EI)
+    clist = c.tolist()
     colist = []  # operational
     mt = 0
 
 #AP wieso 2 for loops?
-#AP dieser part ist für die CTBTO Operational retrieves bis zum aktuellen Tag.
     for elem in clist:
         if 'maxstep' in elem:
@@ -162,7 +148,4 @@
             elem = 'time ' + '${MSJ_BASETIME} {MSJ_BASETIME}'
         colist.append(elem)
-#AP end
-
-#AP whats the difference between clist and colist ?! What is MSJ?
 
     lftextondemand = lftext[:insert_point] + clist + lftext[insert_point + 2:]
@@ -172,15 +155,11 @@
         h.write('\n'.join(lftextondemand))
 
-#AP this is not used ?! what is it for?
-#maybe a differentiation is needed
-    h = open('joboper.ksh', 'w')
-    h.write('\n'.join(lftextoper))
-    h.close()
-#AP end
+    with open('joboper.ksh', 'w') as h:
+        h.write('\n'.join(lftextoper))
 
     # submit job script to queue
     try:
         p = subprocess.check_call(['ecaccess-job-submit', '-queueName',
-                                   queue,' job.ksh'])
+                                   queue, 'job.ksh'])
     except:
         print('ecaccess-job-submit failed, probably eccert has expired')
Index: pythontest/TestTools.py
===================================================================
--- pythontest/TestTools.py	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
+++ pythontest/TestTools.py	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
@@ -0,0 +1,37 @@
+#!/usr/bin/env python
+# -*- coding: utf-8 -*-
+
+import unittest
+import sys
+sys.path.append('../python')
+from Tools import init128, toparamId
+
+
+class TestTools(unittest.TestCase):
+    '''
+    '''
+
+    def setUp(self):
+        pass
+
+    def test_init128(self):
+        '''
+        '''
+        table128 = init128('../grib_templates/ecmwf_grib1_table_128')
+        expected = {'078': 'TCLW', '130': 'T', '034': 'SST'}
+        # check a sample of parameters which must have been read in
+        result = all((k in table128 and table128[k]==v) for k,v in expected.iteritems())
+        self.assertEqual(result, True)
+
+
+    def test_toparamId(self):
+        '''
+        '''
+        table128 = init128('../grib_templates/ecmwf_grib1_table_128')
+        pars = toparamId("T/SP/LSP/SSHF", table128)
+        for par in pars:
+            self.assertIn(par, [130, 134, 142, 146])
+
+
+if __name__ == "__main__":
+    unittest.main()
Index: pythontest/TestUIOFiles.py
===================================================================
--- pythontest/TestUIOFiles.py	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
+++ pythontest/TestUIOFiles.py	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
@@ -0,0 +1,64 @@
+#!/usr/bin/env python
+# -*- coding: utf-8 -*-
+
+import unittest
+import os
+import sys
+sys.path.append('../python')
+import UIOFiles
+
+
+class TestUIOFiles(unittest.TestCase):
+    '''
+    Test class to test the UIOFiles methods.
+    '''
+
+    def setUp(self):
+        '''
+        @Description:
+            Prepare test case. Initialize comparing filelist and
+            the test path.
+
+        @Input:
+            self: instance of TestUIOFiles
+                Class to test the UIOFiles methods.
+
+        @Return:
+            <nothing>
+        '''
+        self.testpath = os.path.join(os.path.dirname(__file__), 'TestDir')
+        self.expected = ['FCGG__SL.20160410.40429.16424.grb',
+                         'FCOG__ML.20160410.40429.16424.grb',
+                         'FCSH__ML.20160410.40429.16424.grb',
+                         'OG_OROLSM__SL.20160410.40429.16424.grb',
+                         'FCOG_acc_SL.20160409.40429.16424.grb',
+                         'FCOG__SL.20160410.40429.16424.grb',
+                         'FCSH__SL.20160410.40429.16424.grb']
+
+        return
+
+    def test_listFiles(self):
+        '''
+        @Description:
+            Test the listFiles method from class UIOFiles.
+
+        @Input:
+            self: instance of TestClass
+                Class to test the UIOFiles methods.
+
+        @Return:
+            <nothing>
+        '''
+
+        # Initialise and collect filenames
+        files = UIOFiles.UIOFiles(['.grb'])
+        files.listFiles(self.testpath, '*')
+        # get the basename to just check for equality of filenames
+        filelist = [os.path.basename(f) for f in files.files]
+        # comparison of expected filenames against the collected ones
+        self.assertItemsEqual(self.expected, filelist)
+
+        return
+
+if __name__ == "__main__":
+    unittest.main()
Index: pythontest/__init__.py
===================================================================
--- pythontest/__init__.py	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
+++ pythontest/__init__.py	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
@@ -0,0 +1,13 @@
+#!/usr/bin/env python
+# -*- coding: utf-8 -*-
+"""
+@Author: Anne Philipp (University of Vienna)
+
+@Date: March 2018
+
+@License:
+    (C) Copyright 2014 UIO.
+
+    This software is licensed under the terms of the Apache Licence Version 2.0
+    which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
+"""
Index: src/Makefile.local.ifort
===================================================================
--- src/Makefile.local.ifort	(revision d69b6776d6d39e0af0d38c95cbfd78284c9866e4)
+++ src/Makefile.local.ifort	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
@@ -12,6 +12,6 @@
 
 
-GRIB_API_INCLUDE_DIR=/usr/local/ifort/grib_api-1.14.3//include
-GRIB_API_LIB=-openmp -L/usr/local/ifort/grib_api-1.14.3/lib -Bstatic  -lgrib_api_f77 -lgrib_api_f90 -lgrib_api -Bdynamic  -lm  -ljasper #-lopenjpeg
+GRIB_API_INCLUDE_DIR=/usr/local/ifort/grib1.12.3//include
+GRIB_API_LIB=-openmp -L/usr/local/ifort/grib1.12.3//lib -Bstatic  -lgrib_api_f77 -lgrib_api_f90 -lgrib_api -Bdynamic  -lm  -ljasper #-lopenjpeg
 
 OPT	= -g
